/**
 * Shibuya CMS 管理画面用JSファイル
 * 自由に編集して頂いて構いません
 */
jQuery(function($){
	
	/**
	 * メディアアップローダーの設定
	 * Media Uploader for WP version above 3.5
	 */
	if( wp.media ){
		var shibuyaCmsUploadCallback = function(e){
			e.preventDefault();
			
			var target = $(this).data( 'uploader-target' );
			if( !target ) {
				alert( 'Please set \'data-uploader-target\' for button.' );
				return;
			}
			
			var uploader = wp.media({
				title: $(this).data( 'uploader-title' ) || 'Media Uplader',
				button: {
					text: $(this).data( 'uploader-button-text' ) || 'Select File'
				},
				multiple: $(this).data( 'uploader-multiple' ) || false
			});
			
			uploader.on( 'select', function() {
				var attachment = uploader.state().get('selection').first().toJSON();
				$(target).val( attachment.id ).trigger('change');
			});
			
			uploader.open();
		};
		
		var shibuyaCmsImageChangeCallback = function(e){
			e.stopPropagation();
			var $img = $(this).parents('.image-box').find('img');
			$.get( SHIBUYA_CMS_IMAGE_URL + '&id=' + $(this).val(), function(url){
				$img.attr( 'src', url );
			});
		};
		
		var shibuyaCmsDblClickCallback = function(e){
			e.stopPropagation();
			$(this).parents('.image-box').find('input').val('').trigger('change');
		};
		
		//アップローダーのコールバックの設定
		if( $().on ){
			$(document).on( 'click', '.uploader', shibuyaCmsUploadCallback );
			$(document).on( 'change', '.image-box input', shibuyaCmsImageChangeCallback );
			$(document).on( 'dblclick', '.image-box img', shibuyaCmsDblClickCallback );
		} else if( $().live ){
			$('.uploader').live( 'click', shibuyaCmsUploadCallback );
			$('.image-box input').live( 'change', shibuyaCmsImageChangeCallback );
			$('.image-box img').live( 'dblclick', shibuyaCmsDblClickCallback );
		}
		
		//エディタの追加
		if( $('.richtext').length ) {
			$('.richtext').css('min-height', 240).each(function(i){
				var target = this;
				
				if( ! $(target).attr('id') ) {
					$(target).attr('id', 'wp-richtext-' + i);
				}
				
				var div    = $('<div class="wp-media-buttons"/>').insertBefore(target).after('<br style="clear:both"/>');
				//buttonはlabel内のクリックで反応するので、labelは使わない
				var button = $('<button type="button" class="button add_media"> ' +
									'<span class="wp-media-buttons-icon"></span> ' +
									'メディアを追加 ' + 
								'</button>').appendTo(div);
				$(button).click(function(e){
					e.preventDefault();
					var uploader = wp.media({
						title: 'Media Uplader',
						button: {
							text: 'Select File'
						},
						multiple: true
					});
					
					uploader.on( 'select', function() {
						var atta = uploader.state().get('selection').first().toJSON();
						if( atta.type == 'image' ) {
							tinymce.activeEditor.insertContent(
									'<a href="' + atta.url + '">' + 
										'<img src="' + atta.url + '" width="'+ atta.width +'" height="'+ atta.height +'" alt="'+ atta.title +'" />' +
									'</a>'
									);
						} else {
							tinymce.activeEditor.insertContent('<a href="' + atta.url + '"></a>');
						}
					});
					
					uploader.open();
				});
			});
			tinymce.init($.extend(shibuyaCmsTinyMCESettings, {
				'selector' : 'textarea.richtext',
				//'height'   : 240,   //not available?
				'resize'   : true,
				'wpautop'  : false
			}));
		}
	}
	
	//チェックボックスやラジオボタンの変更のコールバック
	var shibuyaCmsCheckChangeCallback = function(){
		var name = $(this).attr('name');
		if( name ){
			$('input[name="'+name+'"]').each(function(){
				if( $(this).attr('checked') ){
					$(this).parents('.radio,.checkbox').eq(0).addClass('selected');
				} else {
					$(this).parents('.radio,.checkbox').eq(0).removeClass('selected');
				}
			});
		}
	};
	
	if( $().on ){
		$(document).on( 'change', '.radio input,.checkbox input', shibuyaCmsCheckChangeCallback);
	} else if( $().live ){
		$('.radio input,.checkbox input').live( 'change', shibuyaCmsCheckChangeCallback);
	}
	
	
	//カスタムフィールドデータの呼び出し
	if( shibuyaCmsCustomFields ){
		$('*[name^="@"]').each(function(){
			var tagName = this.tagName.toLowerCase(),
			    name    = $(this).attr('name').replace(/^@/, '');
			
			var type = tagName == 'input'
							? $(this).attr('type').toLowerCase()
							: tagName;
			
			var target = name.replace(/^([^\[]+)/, function(matched){ return "['"+matched+"']" })
											.replace(/\[\]$/, '');
			
			var value = eval( 'shibuyaCmsCustomFields' + target );
			
			if( ! value )
				return;
			
			switch( type ) {
				case 'radio':
				case 'checkbox':
					if( ( $.isArray( value ) && $.inArray( $(this).val(), value ) > -1 )
												|| $(this).val() == value )
						$(this).prop( 'checked', true );
					break;
				default:
					if( ! $.isArray( value ) ) {
						$(this).val( value );
					} else {
						if( name.match(/\[(.*?)\]/) ){
							var key = RegExp.$1;
							if( value[ key ] )
								$(this).val( value[ key ] );
						} else {
							if( value[0] )
								$(this).val( value[0] );
						}
					}
			}
			$(this).trigger('change');
		});
	}
	
	
	//日付選択
	$('.datepicker').datepicker({ dateFormat:'yy-mm-dd' });
	//$('.sortable').sortable();
	
	$('.image-sortable').sortable({
		update: function( event, ui ) {
			$('.image-sortable .image-box').each(function(i){
				var name = '@image['+ i +']';
				$('input[name^="@image"]', this).attr('name', name);
				$('button[data-uploader-target]', this).attr('data-uploader-target', 'input[name="'+ name +'"]');
			});
		}
	});
	
});